[![PyPI version](https://badge.fury.io/py/panpipes.svg)](https://badge.fury.io/py/panpipes)

# Panpipes - multimodal single cell pipelines

## Overview

Panpipes is a set of computational workflows designed to automate multimodal single-cell and spatial transcriptomic analyses by incorporating widely-used Python-based tools to perform quality control, preprocessing, integration, clustering, and reference mapping at scale.
Panpipes allows reliable and customisable analysis and evaluation of individual and integrated modalities, thereby empowering decision-making before downstream investigations.

**See our [documentation](https://panpipes-pipelines.readthedocs.io/en/latest/) and our [preprint](https://www.biorxiv.org/content/10.1101/2023.03.11.532085v2)**  

These workflows make use of [cgat-core](https://github.com/cgat-developers/cgat-core)

Available workflows:

1. "ingest" : Ingest data and compute quality control metrics
2. "preprocess" : Filter and normalize per modality
3. "integration" : Integrate and batch correct using single and multimodal methods
4. "clustering" : Cluster cells per modality
5. "refmap" : Map queries against reference datasets
6. "vis" : Visualize metrics from other pipelines in the context of experiment metadata
7. "qc_spatial" : Ingest spatial transcriptomics data (Vizgen, Visium) and compute quality control metrics
8. "preprocess_spatial" : Filtering and normalize spatial transcriptomics data
9. "deconvolution_spatial" : Deconvolve cell types of spatial transcriptomics slides

## Installation and configuration

For detailed installation instructions (including those for Apple Silicon machines), refer to the [installation instructions here](https://panpipes-pipelines.readthedocs.io/en/latest/install.html).

We recommend installing panpipes in a conda environment.
For that, we provide a minimal conda config file in `pipeline_env.yaml`.
First, clone this repository and navigate to the root directory of the repository:

```bash
git clone https://github.com/DendrouLab/panpipes.git
cd panpipes
```

Then, create the conda environment and install the nightly version of panpipes using the following command:

```bash
conda env create --file=pipeline_env.yaml 
conda activate pipeline_env
pip install -e .
```

Oxford BMRC Rescomp users find additional advice on the installation [here](https://github.com/DendrouLab/panpipes/blob/main/docs/installation_rescomp.md).

## Releases

Since `panpipes v0.4.0`, the `ingest` workflow expects different headers for the RNA and Protein modalities from the previous releases.
Check the example [submission file](https://github.com/DendrouLab/panpipes/blob/main/docs/usage/sample_file_qc_mm.md) and the [documentation](https://panpipes-pipelines.readthedocs.io/en/latest/usage/setup_for_qc_mm.html) for more detailed instructions.

## Citation

[Panpipes: a pipeline for multiomic single-cell and spatial transcriptomic data analysis
Fabiola Curion, Charlotte Rich-Griffin, Devika Agarwal, Sarah Ouologuem, Tom Thomas, Fabian J. Theis, Calliope A. Dendrou
bioRxiv 2023.03.11.532085; doi: https://doi.org/10.1101/2023.03.11.532085](https://www.biorxiv.org/content/10.1101/2023.03.11.532085v2)

## Contributors

Created and Maintained by Charlotte Rich-Griffin and Fabiola Curion.
Additional contributors: Sarah Ouologuem, Devika Agarwal, Lilly May, Kevin Rue-Albrecht, Giulia Garcia, Lukas Heumos.

suppressPackageStartupMessages({
  library(tidyverse)
  library(Seurat)  
  library(optparse)
  library(yaml)
})

option_list <- list(
    make_option(c("--reference_path"), default = "",
                help="path to reference h5mu or seurat object"),
    make_option(c("--query_path"), default = "",
                help="path to query h5mu or seurat object"),
    make_option(c("--wnn_mapping_normalization"), default = "",
                help="wich normalization to apply/was applied to query"),
    make_option(c("--normalize"), default=FALSE,
                help="normalize query?")
    )

opt <- parse_args(OptionParser(option_list=option_list))
message("Running with options:")
print(opt)

check_and_read<- function(reference_path){
if (endsWith( reference_path, ".rds")){
    reference<- readRDS(reference_path)
    refname <- gsub(".rds","",basename(reference_path))
}

if (endsWith( reference_path, ".h5seurat")){
    library(SeuratDisk)
    reference <- LoadH5Seurat(reference_path)
    refname <- gsub(".h5seurat","",basename(reference_path))
}

if (endsWith( reference_path, ".h5mu")){
    library(MuDataSeurat)
    reference = MuDataSeurat::ReadH5MU(reference_path)
    refname <- gsub(".h5mu","",basename(reference_path))
}
if (endsWith( reference_path, ".h5ad")){
    library(SeuratDisk)
    Convert(reference_path, dest = "h5seurat", overwrite = TRUE)
    reference <- LoadH5Seurat(gsub("h5ad","h5seurat",reference_path)
    refname <- gsub(".h5ad","",basename(reference_path))
}



if (!exists("reference")){
    stop("you did not provide a valid object. 
            we support: .h5mu, Seurat saved as .rds or .h5seurat")
}
return(reference)
}

reference<- check_and_read(opt$reference_path)
query <- check_and_read(opt$query_path)


if (!is.null(opt$wnn_mapping_normalization)){
    if(opt$wnn_mapping_normalization == "SCT"){
        if (opt$normalize){
            message("will normalize query data with SCTransform")
            normchoice= "SCT"
            query <- SCTransform(query)
        }else{
            message("your query RNA is pre-normalized with SCTransform")
        }
    }
    if(opt$wnn_mapping_normalization == "LogNormalize"){
        if (opt$normalize){
            message("will normalize query data with LogNormalize")
            normchoice= "LogNormalize"
            query<- NormalizeData(query)
        }else{
            message("your query RNA is pre-normalized with LogNormalize")
        }
    }
}

#force reference reduction to go through spca
if(!"spca"  %in% names(reference@reductions)){
    message("updating reference by computing spca guided by wnn graph")
    reference <- RunSPCA(reference, assay = 'RNA', graph = 'wsnn') 
    #is this how it is called in mudata? check for compatibility
}

anchors <- FindTransferAnchors(
  reference = reference,
  query = query,
  normalization.method = normchoice,
  reference.reduction = "spca",
  dims = 1:50
)

message("Found anchors, now mapping query")
if (file.exists("pipeline.yml")){
    params<- read_yaml("pipeline.yml")
    refdata<-params["refdata"]
}else{
    stop("I don't have a valid refdata param, don't know what to transfer")
    # refdata = list(
    # celltype.l1 = "celltype.l1",
    # celltype.l2 = "celltype.l2",
    # predicted_ADT = "ADT")
}

message("will attempt to predict the following columns/continuous values matrices:")
print(refdata)

query <- MapQuery(
  anchorset = anchors,
  query = query,
  reference = reference,
  refdata = refdata,
  reference.reduction = "spca",
  reduction.model = "wnn.umap"
)

# merge reference and query and save the recomputed Umap instead of the original one
reference$is_reference <- "Reference"
query$is_reference <- "Query"
refquery <- merge(reference, query)
refquery[["spca"]] <- merge(reference[["spca"]], query[["ref.spca"]])
g<-DimPlot(refquery, group.by = 'is_reference', shuffle = TRUE)



ggsave(g, filename = paste0("figures/wnn_reference",refname,"_umap.png", height = 6, width = 8, dpi=300)

refquery <- RunUMAP(refquery, reduction = 'spca', dims = 1:50)
g<-DimPlot(refquery, group.by = 'is_reference', shuffle = TRUE)

ggsave(g, filename = "figures/wnn_recomputed",refname,"_umap.png", height = 6, width = 8, dpi=300)


umap <- FetchData(refquery, vars = c('UMAP_1','UMAP_2'))
write.csv(umap, file= "refmap/umap_",refname,"_wnn.csv", sep=",", col.names=T, row.names=T,quote=F)



saveRDS(refquery, file = "refmap/query_to_reference",refname,"_wnn.rds")
#convert to mudata

# plotting utilities for qc 
suppressPackageStartupMessages({
  library(tidyverse)
  library(optparse)
})

do_scatter_plot <- function(df, x, y, facet=NULL, hue=NULL){
  g <- df %>% 
    ggplot(aes_string(x=x,y=y, color=hue)) + 
    geom_point(size=0.5) 
  if (!is.null(facet)){
    g <- g + facet_wrap(as.formula(paste0("~", sc)), ncol=6) 
  }
  
  if(is.numeric(df[hue])){
    g <- g + scale_color_viridis_c()
  }
  g <- g+ theme_bw()+
    theme(axis.text.x=element_text(angle=90, hjust=1, vjust=0.5),
          strip.text.x = element_text(size=6),
          legend.key.size = unit(0.2, 'cm')) 
  return(g)
}

do_violin_plot <- function(df, qc, group){
  g <- df %>% drop_na() %>%
    ggplot(aes_string(x="sample_id",y=qc)) +
    geom_violin(aes_string(fill=group)) + 
    {if(qc=="doublet_scores") geom_hline(yintercept=0.25, color="grey50", linetype="dashed") }+
    {if("pct_counts" %in% qc) geom_hline(yintercept=c(5, 10, 20 ,70), color="grey50", linetype="dashed")}+
    {if("pct_counts" %in% qc) coord_cartesian(ylim=c(0,100))}+
    theme_bw()+
    theme(axis.text.x=element_text(size=8, angle=90),
          axis.text.y=element_text(size=8))
  if(length(unique(df[[group]])) > 10){
    message(paste0(sc, "has too many categories, removing legend"))
    g <- g + theme(legend.position="none")
  }
  
  return(g)
}

do_bar_plot <- function(df, qc, group){
  g <- df %>%
    ggplot(aes_string(x=group, fill=qc)) +
    geom_bar(aes_string()) + 
    theme_bw()+
    theme(axis.text.x=element_text(size=8, angle=90),
          axis.text.y=element_text(size=8))
#   if(length(unique(df[[group]])) > 10){
#     message(paste0(sc, "has too many categories, removing legend"))
#     g <- g + theme(legend.position="none")
#   }
  
  return(g)
}

options(stringsAsFactors = F)
options(bitmaptype="cairo")

option_list <- list(
  make_option(c("--cell_metadata"), default=NULL,
              help="the path to the anndata object"),
  make_option(c("--groupingvar"), default="sample_id,tissue,patient,channel",
              help="names of grouping variables"),
  make_option(c("--rna_qc_metrics"), default=NULL, 
              help="the qc_metrics to plot"),
  make_option(c("--prot_qc_metrics"), default=NULL, 
              help="the qc_metrics to plot"),
  make_option(c("--rep_qc_metrics"), default=NULL, 
              help="the qc_metrics to plot"),
  make_option(c("--atac_qc_metrics"), default=NULL, 
              help="the qc_metrics to plot"),
  make_option(c("--outdir"), default="./figures/",
              help="the name of the output folder"),
  make_option(c("--prefilter"), default=TRUE,
              help="am i parsing data before or after filtering?"),
  make_option(c("--sampleprefix"), default="",
              help="the prefix to prepend to save summary filtering plots"),
  make_option(c("--scanpy_or_muon"), default="scanpy", 
              help="was the input file written out from the obs of scanpy or muon")
)


message("Plot QC data")
opt <- parse_args(OptionParser(option_list=option_list))

if(is.null(opt$outdir)) { opt$outdir <- paste0(getwd(),"/")}
if(!grepl("\\/$", opt$outdir)){opt$outdir <- paste(opt$outdir, "/", sep = "")}
if(!file.exists(opt$outdir)){dir.create(opt$outdir)}

print("Running with options:")
print(opt)

run<- opt$outdir
opt[which(opt=="NULL")] <- NULL
opt[which(opt=="None")] <- NULL
opt$prefilter <- as.logical(opt$prefilter)

# load_data --------------------------------------------------------------------

data_plot = read.delim(opt$cell_metadata)

# define source facet for all plots
if (!is.null(opt$groupingvar)){
  source_facet <- strsplit(opt$groupingvar,",")[[1]]
  check_excl <- source_facet[!source_facet %in% colnames(data_plot)] 
  keep_source <- NULL
  for (cc in check_excl){
    for (mod in c("rna","prot","atac","rep")){
      id <- paste(mod,cc,sep=".")
      if(id %in% colnames(data_plot)){
        keep_source <- c(keep_source,id)
      }
    }
  }

  source_facet <- source_facet[source_facet %in% colnames(data_plot)]
  source_facet <- unique(c(source_facet, keep_source) )
  if(length(source_facet)>0){
    print("Facet plotting with")
    # add sample_id as a minimum requirement if it's not there already
    source_facet = unique(c("sample_id", source_facet))
    print(source_facet)
  }
}else{
  stop("i don't have the minimum variable _sampleid_ to facet on, will stop here")
}
# RNA plots --------------------------------------------------------------------


if(opt$scanpy_or_muon=="scanpy"){
  rna_data_plot <- data_plot
}else{
  rna_data_plot <- data_plot[,grep("^rna\\.",colnames(data_plot))]
  colnames(rna_data_plot) <- gsub("^rna\\.", "", colnames(rna_data_plot))
}

outpath = file.path(run, "rna")
if (!dir.exists(outpath)) dir.create(outpath)


# this is not forced anymore
# I'm removing the illusion of choice because QC metrics only applies to the violin plots anyway.
# qcmetrics=c("total_counts",
#             "log1p_total_counts",
#             "n_genes_by_counts",
#             "log1p_n_genes_by_counts",
#             "doublet_scores", 
#             "pct_counts_mt", 
#             "pct_counts_rp", 
#             "pct_counts_ig",
#             "pct_counts_hb")

# check these qc metrics are in the file
if (!is.null(opt$rna_qc_metrics)) {
  qcmetrics <- strsplit(opt$rna_qc_metrics,",")[[1]]
}
qcmetrics <- qcmetrics[qcmetrics %in% colnames(rna_data_plot)]
uniq_sample_id <- nrow(unique(rna_data_plot["sample_id"]))
rna_source_facet <- gsub("^rna\\.", "",grep("^rna.", source_facet, value = TRUE))
rna_source_facet <- unique(c(rna_source_facet, source_facet[!grepl("^rna.", source_facet)]))
rna_source_facet <- rna_source_facet[rna_source_facet %in% colnames(rna_data_plot)]
for (qc in qcmetrics){
  print(qc)
  for (sc in rna_source_facet){ #add gsub temp here
    print(sc)
    g <- do_violin_plot(rna_data_plot, qc, sc)
    if (uniq_sample_id  > 50){width=12}else{width=6}
    ggsave(g, filename=file.path(outpath, paste0("violin_", sc, "_rna-", qc,".png")), type="cairo", width= width, height=6)
    
  }
}

for (sc in rna_source_facet){
  uniq_source <- nrow(unique(rna_data_plot[sc]))
  if(uniq_source >6){
    ncols=6
    nrows=ceiling(uniq_source/6)
  }else{
    ncols=uniq_source
    nrows=1
  }
  # plot once per source facet
  if (all(c("total_counts","n_genes_by_counts")%in% colnames(rna_data_plot))){
    g <- do_scatter_plot(rna_data_plot,x="total_counts",y="n_genes_by_counts", facet=sc)
    ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_rna-nUMI_v_rna-genes.png")), type="cairo",
           width= 3*ncols, height=3*nrows, dpi=200)
  }
  
  if (all(c("log1p_total_counts","log1p_n_genes_by_counts")%in% colnames(rna_data_plot))){
    
    g <- do_scatter_plot(rna_data_plot,x="log1p_total_counts",y="log1p_n_genes_by_counts", facet=sc)
    ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_rna-log1p_nUMI_v_rna-log1p_genes.png")), type="cairo",
           width= 3*ncols, height=3*nrows, dpi=200)
  }
  if (all(c("total_counts","pct_counts_mt")%in% colnames(rna_data_plot))){
    g <- do_scatter_plot(rna_data_plot,x="total_counts",y="pct_counts_mt", facet=sc)
    ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_rna-nUMI_v_rna-pct_mt.png")), type="cairo",
           width= 3*ncols, height=3*nrows, dpi=200)
  }
  if (all(c("n_genes_by_counts","doublet_scores","total_counts")%in% colnames(rna_data_plot))){
    g <- do_scatter_plot(rna_data_plot,x="n_genes_by_counts",y="doublet_scores",
                         hue="total_counts", facet=sc)
    ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_rna-genes_rna-doublet_scores_rna-numi.png")),    
           type="cairo", width= 3*ncols, height=3*nrows, dpi=200)
  }
  
}



# Protein plots ----------------------------------------------------------------


if(!is.null(opt$prot_qc_metrics)){
  qcmetrics <- strsplit(opt$prot_qc_metrics,",")[[1]]
  prot_data_plot <- data_plot[,grep("^prot\\.",colnames(data_plot))]
  colnames(prot_data_plot) <- gsub("^prot\\.", "", colnames(prot_data_plot))
  prot_source_facet <- gsub("^prot\\.", "",grep("^prot.", source_facet, value = TRUE))
  prot_source_facet <- unique(c(prot_source_facet, source_facet[!grepl("^prot.", source_facet)]))
  prot_source_facet <- prot_source_facet[prot_source_facet %in% colnames(prot_data_plot)]

  outpath = file.path(run, "prot")
  if (!dir.exists(outpath)) { 
    dir.create(outpath)
    }
  uniq_sample_id <- nrow(unique(prot_data_plot["sample_id"]))

  # check these qc metrics are in the file
  qcmetrics <- qcmetrics[qcmetrics %in% colnames(prot_data_plot)]
  for (qc in qcmetrics){
    print(qc)
    for (sc in prot_source_facet){
      g <- do_violin_plot(prot_data_plot, qc, sc)
      if (uniq_sample_id  > 50){width=12}else{width=6}
      ggsave(g, filename=file.path(outpath, paste0("violin_", sc, "_prot-", qc,".png")), type="cairo", width= width, height=6)
    }
  }
  
  # do the following plots:
  # - prot:total_counts vs prot_nprot_by_counts
  # - prot:total_counts vs prot:isotype_counts
  # - prot:log1p_total_counts vs prot:log1p_isotype_counts
  # - prot:total_counts vs prot:pct_isotype_counts
  
  
  for (sc in prot_source_facet){
    uniq_source <- nrow(unique(prot_data_plot[sc]))
    if(uniq_source >6){
      ncols=6
      nrows=ceiling(uniq_source/6)
    }else{
      ncols=uniq_source
      nrows=1
    }
    # plot once per source facet
    message("protein scatter plots")  
    if (all(c("total_counts","n_prot_by_counts")%in% colnames(prot_data_plot))){
      g <- do_scatter_plot(prot_data_plot,x="total_counts",y="n_prot_by_counts", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_prot-nUMI_v_prot-prot.png")), type="cairo",
             width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("log1p_total_counts","log1p_n_prot_by_counts")%in% colnames(prot_data_plot))){
      g <- do_scatter_plot(prot_data_plot,x="log1p_total_counts",y="log1p_n_prot_by_counts", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_prot-log1p_nUMI_v_prot-log1p_prot.png")), type="cairo",
             width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("total_counts","pct_counts_isotype")%in% colnames(prot_data_plot))){
      g <- do_scatter_plot(prot_data_plot,x="total_counts",y="pct_counts_isotype", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_prot-nUMI_v_prot-pct_isotype.png")), type="cairo",
             width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("total_counts","total_counts_isotype")%in% colnames(prot_data_plot))){
      g <- do_scatter_plot(prot_data_plot,x="total_counts",y="total_counts_isotype", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_prot-nUMI_v_prot-total_counts_isotype.png")), type="cairo",
             width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("log1p_total_counts","log1p_total_counts_isotype", "isotype_exclude")%in% colnames(prot_data_plot))){
      g <- do_scatter_plot(prot_data_plot,x="log1p_total_counts",y="log1p_total_counts_isotype", hue="isotype_exclude", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "_prot-log1p_nUMI_v_prot-log1p_total_counts_isotype.png")), type="cairo",
             width= 3*ncols, height=3*nrows, dpi=200)
    }
  }

}
# Atac plots ----------------------------------------------------------------


if(!is.null(opt$atac_qc_metrics)){
  message("Atac plots")
  atac_data_plot <- data_plot[,grep("^atac\\.",colnames(data_plot))]
  colnames(atac_data_plot) <- gsub("^atac\\.", "", colnames(atac_data_plot))
  atac_source_facet <- gsub("^atac\\.", "",grep("^atac.", source_facet, value = TRUE))
  atac_source_facet <- unique(c(atac_source_facet, source_facet[!grepl("^atac.", source_facet)]))
  atac_source_facet <- atac_source_facet[atac_source_facet %in% colnames(atac_data_plot)]


  outpath = file.path(run, "atac")
  if (!dir.exists(outpath)) dir.create(outpath)
  
  uniq_sample_id <- nrow(unique(atac_data_plot["sample_id"]))

  # check these qc metrics are in the file
  qcmetrics <- qcmetrics[qcmetrics %in% colnames(atac_data_plot)]
  for (qc in qcmetrics){
    print(qc)
    for (sc in atac_source_facet){
      g <- do_violin_plot(atac_data_plot, qc, sc)
      if (uniq_sample_id  > 50){width=12}else{width=6}
      ggsave(g, filename=file.path(outpath, paste0("violin_", sc, "_atac-", qc,".png")), type="cairo", width= width, height=6)
    }
  }
}
  
# Rep plots ----------------------------------------------------------------


if (!is.null(opt$rep_qc_metrics)) {
  message("Repertoire plots")
  qcmetrics <- strsplit(opt$rep_qc_metrics,",")[[1]]
  qcmetrics <- gsub("rep:", "", qcmetrics)
  rep_data_plot <- data_plot[,grep("^rep\\.",colnames(data_plot))]
  colnames(rep_data_plot) <- gsub("^rep\\.", "", colnames(rep_data_plot))
  rep_data_plot = rep_data_plot %>% filter(sample_id!="")
  
  rep_source_facet <- gsub("^rep\\.", "",grep("^rep.", source_facet, value = TRUE))
  rep_source_facet <- unique(c(rep_source_facet, source_facet[!grepl("^rep.", source_facet)]))
  rep_source_facet <- rep_source_facet[rep_source_facet %in% colnames(rep_data_plot)]

  
  outpath = file.path(run, "rep")
  if (!dir.exists(outpath)) dir.create(outpath)
  
  
  uniq_sample_id <- nrow(unique(rep_data_plot["sample_id"]))

  # check these qc metrics are in the file
  qcmetrics <- qcmetrics[qcmetrics %in% colnames(rep_data_plot)]
  for (qc in qcmetrics){
    for (sc in rep_source_facet){
      g <- do_bar_plot(rep_data_plot, qc, sc)
      if (uniq_sample_id  > 50){width=12}else{width=6}
        ggsave(g, filename=file.path(outpath, paste0("bar_", sc, "_rep-", qc,".png")), type="cairo", width= width, height=6)

      if (!(qc %in% c('has_ir', "receptor_type"))){
        g <- do_bar_plot(rep_data_plot, qc, sc) + facet_grid(~receptor_type)
        ggsave(g, filename=file.path(outpath, paste0("bar_facet_", sc, "_rep-", qc,".png")), type="cairo", width= width*4, height=6)

      }
    }
  }
}


if(!is.null(opt$prot_qc_metrics)){

# rna vs prot plots ----------------------------------------------------------------
  

  outpath = file.path(run, "rna_v_prot")
  if (!dir.exists(outpath)) dir.create(outpath)    
  

  for (sc in source_facet){
    
    message(sc)
    uniq_source <- nrow(unique(data_plot[sc]))
    if(uniq_source >6){
      ncols=6
      nrows=ceiling(uniq_source/6)
    }else{
      ncols=uniq_source
      nrows=1
    }
    message("rna v protein scatter plots")  
    if (all(c("rna.total_counts","prot.total_counts")%in% colnames(data_plot))){
      g <- do_scatter_plot(data_plot,x="rna.total_counts",y="prot.total_counts", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "-nUMI_v_rna-nUMI.png")), type="cairo",
              width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("rna.log1p_total_counts","prot.log1p_total_counts")%in% colnames(data_plot))){
      g <- do_scatter_plot(data_plot,x="rna.log1p_total_counts",y="prot.log1p_total_counts", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "-log1p_nUMI_v_rna-log1p_nUMI.png")), type="cairo",
              width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("rna.total_counts","prot.total_counts_isotype")%in% colnames(data_plot))){
      g <-  do_scatter_plot(data_plot,x="rna.total_counts",y="prot.total_counts_isotype", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "-nUMI_v_prot-counts_isotype.png")), type="cairo",
              width= 3*ncols, height=3*nrows, dpi=200)
    }    
    if (all(c("rna.log1p_total_counts","prot.log1p_total_counts_isotype") %in% colnames(data_plot))){
      g <-  do_scatter_plot(data_plot,x="rna.log1p_total_counts",y="prot.log1p_total_counts_isotype", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "-log1p_nUMI_v_prot-log1p_counts_isotype.png")), type="cairo",
              width= 3*ncols, height=3*nrows, dpi=200)
    }
    if (all(c("rna.doublet_scores","prot.log1p_total_counts") %in% colnames(data_plot))){
      g <-  do_scatter_plot(data_plot,x="rna.doublet_scores",y="prot.log1p_total_counts", facet=sc)
      ggsave(g, filename=file.path(outpath, paste0("scatter_", sc, "-doublet_scores_v_prot-log1p_nUMI.png")), type="cairo",
              width= 3*ncols, height=3*nrows, dpi=200)
      
    }
    
    
  }
  
}


sprefix <- opt$sampleprefix
print(sprefix)
message ("saving some counts tables for references")


if(opt$prefilter){
  if(all(c("pct_counts_mt", "pct_counts_hb", "n_genes_by_counts", "doublet_scores") %in% colnames(rna_data_plot))){
    f1 <- rna_data_plot %>% 
      dplyr::filter(pct_counts_mt<=20 & pct_counts_hb<=70 &n_genes_by_counts>=100 & doublet_scores<=0.25) %>%
      group_by_at(.vars=c(rna_source_facet)) %>%
      group_by_at(.vars=c(rna_source_facet)) %>%
      summarise(cell.count= n()) %>%
      group_by_at(.vars="sample_id") %>% 
      rename(cell.count_f1=cell.count) 
    
    f2 <- rna_data_plot %>% 
      dplyr::filter(pct_counts_mt<=10 & pct_counts_hb<=50 &n_genes_by_counts>=100 & doublet_scores<=0.25) %>%
      group_by_at(.vars=c(rna_source_facet)) %>%
      summarise(cell.count= n()) %>% 
      group_by_at(.vars="sample_id") %>% 
      rename(cell.count_f2=cell.count) 
    
    f3 <- rna_data_plot %>% 
      dplyr::filter(pct_counts_mt<=5 & pct_counts_hb<=50 &n_genes_by_counts>=100 & n_genes_by_counts<=3000) %>%
      group_by_at(.vars=c(rna_source_facet)) %>%
      summarise(cell.count= n()) %>% 
      group_by_at(.vars="sample_id") %>% 
      rename(cell.count_f3=cell.count) 
    
    baseline <- rna_data_plot %>% 
      group_by_at(.vars=c(rna_source_facet)) %>%
      summarise(cell.count= n()) %>% 
      group_by_at(.vars="sample_id") %>% 
      rename(baseline.counts=cell.count)
    
    info <- merge(merge(merge(f1,f2,by=rna_source_facet,all=TRUE),f3, by=rna_source_facet, all=TRUE), baseline, by=rna_source_facet, all=T) %>%
      mutate(percent_retain_f1 = 100*cell.count_f1/baseline.counts,
             percent_retain_f2 = 100*cell.count_f2/baseline.counts,
             percent_retain_f3 = 100*cell.count_f3/baseline.counts) 
    
    
    
    write.table(info, file=paste0( sprefix,"_threshold_filter.tsv"), col.names=T, row.names=F, sep="\t", quote=F)
    
    explain <- data.frame(qcmetric=c("pct_counts_mt_max","pct_counts_hb_max","n_genes_by_counts_min","doublet_scores_max","n_genes_by_counts_max"),
                          f1=c(20,70,100,0.25,NA),
                          f2=c(10,50,100,0.25,NA),
                          f3=c(5,50,100,NA,3000)) 
    
    write.table(explain, file=paste0(sprefix,"_threshold_filter_explained.tsv"), col.names=T, row.names=F, sep="\t", quote=F)
    
    lab <- c("%Mt <=10 & %HB<70 & minGenes>=100 & scrublet<=0.25",
             "%Mt <=5 & %HB<50 & minGenes>=100 & scrublet<=0.25",
             "%Mt <=5 & %HB<50 & minGenes>=100 & maxGenes<=3000")
    names(lab) <- c("percent_retain_f1","percent_retain_f2","percent_retain_f3") 
    
    g <- info %>% 
      pivot_longer(cols=starts_with("percent"), names_to="filterclass", values_to="percent")%>%
      ggplot(aes(sample_id,percent, fill=filterclass)) +
      geom_bar(stat="identity", position="dodge", color="black") +
      facet_wrap(~filterclass, ncol=1, labeller = labeller(filterclass=lab)) +
      theme_bw()+
      theme(axis.text.x=element_text(size=8,angle=45, hjust=1, vjust=1),
            axis.text.y=element_text(size=13)) +
      scale_fill_manual(values = c("red", "yellow","blue"), 
                        breaks=c("percent_retain_f1","percent_retain_f2","percent_retain_f3"),
                        limits=c("percent_retain_f1","percent_retain_f2","percent_retain_f3")) + 
      coord_cartesian(ylim=c(0,100)) 
    
    ggsave(g, file = paste0(run,"barplot_cellcounts_thresholds_filter.png"), type="cairo", width=9, height=9)
  }
  
}else{
  message("producing files with final counts for cells after filtering")
  
  baseline <- rna_data_plot %>% 
    group_by_at(.vars=c(rna_source_facet)) %>% 
    summarise(cell.count= n()) %>% 
    group_by_at(.vars="sample_id") 
  
  write.table(baseline, file=paste0( sprefix,"_filtered_data.tsv"), col.names=T, row.names=F, sep="\t", quote=F)
  
  g <- baseline %>% 
    ggplot(aes_string(x="sample_id", y="cell.count")) +
    geom_bar(stat="identity", position="dodge", color="black") +
    theme_bw()+
    theme(axis.text.x=element_text(size=8,angle=45, hjust=1.05, vjust=0.95),
          axis.text.y=element_text(size=13)) 
  ggsave(g, file = file.path(run, "rna","barplot_cellcounts_filtered_data.png"), type="cairo", width=9, height=6)
  
}


message("done")

library(tidyverse)
library(ggplot2)
library(yaml)
library(cowplot)
library(magrittr)
library(optparse)
options(stringsAsFactors = F)
options(bitmaptype="cairo" )

scale_y_origin <- function(...) {
	scale_y_continuous(expand = expansion(mult = c(0, 0.05)), ...)
}

panpipes_theme <- function(font_size=10) {
	theme(
		text = element_text(size=font_size),
		
		panel.border = element_rect(colour = "black", fill=NA),
		# color background 2)
		panel.background = element_rect(fill = "white"),
		# modify grid 3)
		# panel.grid.major.x = element_line(colour = "black", linetype = 3, size = 0.5),
		# panel.grid.minor.x = element_blank(),
		panel.grid.major =  element_line(colour = "grey", linetype = 3, size = 0.5),
		# panel.grid.minor.y = element_blank(),
		# modify text, axis and colour 4) and 5)	
		axis.text = element_text(size=font_size),
		axis.title = element_text(size=font_size),
		# axis.ticks = element_line(colour = "steelblue"),
		plot.title = element_text(hjust = 0.5),
		# legend at the bottom 6)
		legend.position = "bottom",
		
	)
}

parse_cell_metadata <- function(cmtd, cat_vars, grp_vars){
	colnames(cmtd) <- gsub(":", "_", colnames(cmtd))
	if("rep_has_ir" %in% colnames(cmtd)){
		cmtd$rep_has_ir = cmtd$rep_has_ir %>% replace_na(FALSE)
	}
	cmtd %<>% mutate(across(cat_vars$variable, factor))
	cmtd %<>% mutate(across(grp_vars$variable, factor))
	return(cmtd)
}

parse_vars <- function(cat_vars){
    if (is.list(cat_vars)){
        uniq_cat_vars <- unique(unlist(cat_vars))
        uniq_cat_vars
        # cat vars
        cat_split = data.frame(str_split(uniq_cat_vars, ":", simplify = T)) %>%
            mutate(mod =ifelse(X1 %in% c('rna', 'prot', 'atac', 'rep'), X1, "multimodal"),
                        variable = gsub(":", "_", uniq_cat_vars)) %>% 
            select(mod, variable)
    }else{
        cat_split = data.frame(variable=gsub(":", "_", cat_vars))
    }
	return(cat_split)
}

# Get options ----------------------------------------------------------------
option_list <- list(
	make_option(c("--mtd_object"),help="tsv file containing per cell metrics for plotting"),

	make_option(c("--params_yaml"), default="pipeline.yml",help="yml file in the format expected by panpipes vis")
	
)

opt <- parse_args(OptionParser(option_list=option_list))
message("Running with options:")
print(opt)

# load_data ----------------------------------------------------------------

cmtd = data.table::fread(opt$mtd_object, sep='\t', na.strings = "")

PARAMS = yaml::read_yaml(opt$params_yaml)

grp_vars =  parse_vars(PARAMS$grouping_vars)

cont_vars = parse_vars(PARAMS$continuous_vars)
cat_vars = parse_vars(PARAMS$categorical_vars)

cmtd <- parse_cell_metadata(cmtd, cat_vars, grp_vars)



# Barplots ----------------------------------------------------------------
if( PARAMS$do_plots$categorical_barplots){
    for( mod in unique(cat_vars$mod)){
        if (!dir.exists(file.path(mod))) dir.create(file.path(mod))
        print(mod)
        uniq_cat_vars = cat_vars[cat_vars$mod == mod, 'variable']
        
        for (cat_v in uniq_cat_vars){
            print(cat_v)
            plt_title <- cat_v
            plot_dat = cmtd %>% 
                mutate(!! cat_v  := factor(!! rlang::sym(cat_v))) %>% 
                group_by(!!sym(cat_v)) %>% 
                summarise(n_cells=n()) %>% 
                drop_na()
            
            # coord flip if samples have long names
            flip_axes <- max(nchar(as.character(plot_dat[[cat_v]] ))) > 10

            p1 <- ggplot(plot_dat,  aes_string(x=cat_v, y="n_cells", fill=cat_v )) +
                geom_col() +
                ggtitle(cat_v) +
                scale_y_origin() + 
                panpipes_theme() + 
                theme(legend.position = "none")
            if (flip_axes){
                p1 <- p1 + coord_flip()
            }
        
        print(paste0("saving to: ", file.path(mod, paste0("bar_", cat_v, ".png"))))
        save_plot(filename=file.path(mod, paste0("bar_", cat_v, ".png")),
                            plot=p1, ncol=1, 
                            nrow=1,base_asp = 1.3, base_height = 5) 
    }
}
}
# Stacked barplots by grouping var ----------------------------------------------------------------
if( PARAMS$do_plots$categorical_stacked_barplots){

    for( mod in unique(cat_vars$mod)){
        print(mod)
        uniq_cat_vars = cat_vars[cat_vars$mod == mod, 'variable']
        
        for( gv in grp_vars$variable){
            print(gv)
            if (!dir.exists(file.path(mod, gv))) dir.create(file.path(mod, gv), recursive=T)
            stacked_barplots <- list()
        
            for (cat_v in uniq_cat_vars){
                
                if( gv == cat_v){
                    print("skipping")
                    next
                }
                
                plot_dat = cmtd %>% select(!!sym(gv), !!sym(cat_v)) %>% 
                    drop_na() %>% 
                    group_by( !!sym(gv), !!sym(cat_v)) %>% 
                    summarise(n_cells=n()) %>% ungroup() %>% group_by(!!sym(gv)) %>% 
                    mutate(proportion= n_cells / sum(n_cells)) 
                    # drop_na()
                # coord flip if samples have long names
                flip_axes <- max(nchar(as.character(plot_dat[[gv]] ))) > 10
                
                p1 <- ggplot(plot_dat,  aes_string(x=gv, y="n_cells", fill=cat_v)) + 
                    geom_col() + 
                    # ggtitle(plt_title) + 
                    scale_y_origin() + 
                    panpipes_theme(font_size = 10) 

                p2 <- ggplot(plot_dat,  aes_string(x=gv, y="proportion", fill=cat_v)) + 
                    geom_col() + 
                    # ggtitle(plt_title) + 
                    scale_y_origin() + 
                    panpipes_theme(font_size = 10)
                
                if (flip_axes){
                    p1 <- p1 + coord_flip()
                    p2 <- p2 + coord_flip()
                }
                pg <- cowplot::plot_grid(p1, p2)
                save_plot(filename=file.path(mod, gv, paste0("stackedbar_", cat_v, ".png")),
                                    plot=pg, ncol=2, 
                                    nrow=1, base_height = 5, 
                                    base_asp = ifelse(flip_axes, 1.5, 1.1)) 
            }
        }
        
        
    }
}

# Violin by grouping var ----------------------------------------------------------------
if( PARAMS$do_plots$continuous_violin){


    for( mod in unique(cont_vars$mod)){
        print(mod)
        uniq_cont_vars = cont_vars[cont_vars$mod == mod, 'variable']
        
        for( gv in grp_vars$variable){
            print(gv)
            if (!dir.exists(file.path(mod, gv))) dir.create(file.path(mod, gv), recursive=T)

            stacked_barplots <- list()
            
            for (cont_v in uniq_cont_vars){
                
                if( gv == cont_v) next
                
                # plot_dat = cmtd %>% group_by( !!sym(gv), !!sym(cont_v)) %>% 
                #     summarise(n_cells=n()) %>%
                #     mutate(proportion= n_cells / sum(n_cells)) %>% 
                #     drop_na()
                # coord flip if samples have long names
                plot_dat = cmtd %>% filter(!is.na(!!sym(cont_v)) & !is.na(!!sym(gv)))
                flip_axes <- max(nchar(as.character(plot_dat[[gv]] ))) > 10
                
                p1 <- ggplot(plot_dat,  aes_string(x=gv, y=cont_v, fill=gv)) + 
                    geom_violin() + 
                    # ggtitle(plt_title) + 
                    scale_y_origin() + 
                    panpipes_theme(font_size = 10) 
                
                
                if (flip_axes){
                    p1 <- p1 + coord_flip()
                }

                save_plot(filename=file.path(mod, gv, paste0("violin_", cont_v, ".png")),
                                    plot=p1, ncol=1, 
                                    nrow=1, base_height = 5, 
                                    base_asp = ifelse(flip_axes, 1.5, 1.1)) 
            }
        }
        
        
    }

}

# Clustree diagram from aggregated cluster data.
# Script originally written by Fabiola Curion, adapted by Charlotte Rich-Griffin
####


library(clustree)
library(dplyr)
library(optparse)
library(ggplot2)
library(readr)


option_list <- list(
    make_option(c("--infile"), default="none",
                help="a comma separated list of clustering files"),
	make_option(c("--plot_title"), default="none",
                help="file prefix for clustree to use as input"),
  	make_option(c("--outfile"), default="clustree.png",help = "save file")
    )

opt <- parse_args(OptionParser(option_list=option_list))

# 1. mload and merge infiles
# 2. name columns
# 3. run clustree

message("Running with options:")

print(opt)

# # run clustree
m = readr::read_tsv(opt$infile)
# this is a little dodge, but works ;) 
example_column=colnames(m)[2]
col_prefix=substr(example_column, 1, nchar(example_column)-3 )
# run clustree
gg <- clustree(m, prefix =col_prefix) + ggtitle(opt$plot_title)


if (!(dir.exists(dirname(opt$outfile)))){
	dir.create(dirname(opt$outfile))
}

# save
ggsave(gg, filename=opt$outfile, height=10,width=12, type="cairo")

message("clustree done")

# Plot cluster metrics based on clusters from python/run_clustering.py
# Script originally written by Fabiola Curion, adapted to take python outputs by Charlotte Rich-Griffin
####


library(optparse)
library(Seurat)
library(dplyr)
library(tidyselect)
library(ggplot2)
library(foreign)
library(xtable)
library(stringr)
library(reticulate)
library(ggrepel)

set.seed(42)
option_list <- list(
	make_option(c("--mtd_object"), default="none",help="seurat or scanpy object to take as input"),
	make_option(c("--mtd_type"), default=NULL, help="specify whether a seurat or scanpy object \
	              is  the input type, leave blank for txt file, default=NULL"),
	make_option(c("--coords"), default="none",
							help="A txt file containing coordinates froma dimension reduction"),
	make_option(c("--coords_suffix"), default="", help="string to add to umap plots filenames, optional"),
	make_option(c("--clusterid"), default="none",
							help="An rds object containing the cluster identities"),
	make_option(c("--continuous_variables"), default='percent.mito',
				help="continuous variables to plot, csv list of variables stored in adata.obs"),
	make_option(c("--discrete_variables"), default="condition",
							help="variables to use to plot. Should be a comma separated list"),
	make_option(c("--dimred"), default='umap',
							help="What dim reduction to use for the cell dimred space. Default to umap. Needs a tsne.txt table to be precomputed (pca,umap) "),
	make_option(c("--outfile_prefix"), default=NULL,
							help="prefix for output files, (should contain parameters)")
	)

opt <- parse_args(OptionParser(option_list=option_list))
message("Running with options:")
print(opt)

message("Saving to:")
if(grepl('/', opt$outfile_prefix)){
	out_path = paste0(dirname(opt$outfile_prefix), '/')
}else{
	out_path='./'
}
print(out_path)



# read in metadata
if(is.null(opt$mtd_type)){
	mtd <- read.table(opt$mtd_object, sep='\t', header=TRUE, row.names=1)
	print(colnames(mtd))
}else if(opt$mtd_type == "scanpy"){
	sc <- reticulate::import("scanpy")
	# use scanpy to read in anndata
	adata= sc$read_h5ad(opt$mtd_object)
	mtd = adata$obs
} else if(opt$mtd_type == "seurat"){
	seu = readRDS(opt$mtd_object)
	mtd = seu@meta.data
} else{
	mtd <- read.table(opt$mtd_object, sep='\t', header=TRUE, row.names=1)
}




cont_plot <- strsplit(opt$continuous_variables,",")[[1]]
# necessary to do this gsub because of how R parses the muon obs data
cont_plot = sapply(cont_plot, function(x) gsub(":", "\\.", x))
print("continuous variables to plotted")
print(cont_plot[which(unlist(cont_plot) %in% colnames(mtd))])
print("continuous variables not found in metadata")
print(cont_plot[!(which(unlist(cont_plot) %in% colnames(mtd)))])

# read in coordinates
tt<-read.table(opt$coords, header=T, sep='\t', row.names=1)
colnames(tt) <- c('UMAP_1', 'UMAP_2')

# merge mtd and tt
# what if data has been downsampled? 
tt <- merge(tt, mtd, by=0, all.y=T)
tt = tibble::column_to_rownames(tt, "Row.names")
# read in cluster id
cl.id <- read.table(opt$clusterid, sep='\t', header=TRUE, row.names = 1)

tt <- merge(tt, cl.id, by=0, all.x=T,, all.y=F)
tt$cluster <- factor(tt$clusters)
tt = tibble::column_to_rownames(tt, "Row.names")

##dim reduction plots 

if(opt$dimred=="umap"){
	plout = opt$outfile_prefix
	print("plotting prefix")
	print(plout)

  # plot continuous variables on umap 
  print("---------------")
  print("plot continuous variables" )
  print("---------------")

	for(cp in cont_plot){
		print(cp)
		tt %>% ggplot(aes_string("UMAP_1","UMAP_2", color=cp)) +
			geom_point(size=0.3) + scale_color_viridis_c() + theme_bw() +
			theme(legend.key.height=unit(0.5,'cm'), legend.key.width=unit(0.1,'cm'), axis.title = element_text(size=15), axis.text = element_text(size=14)) -> g
		ggsave(g, filename=paste0(opt$outfile_prefix,"_",cp,"_", opt$coords_suffix, ".png" ), width=7, height=6, type="cairo", dpi=120)
	}
	
	# plot discrete variables on umap 
	
	varplot1 <- strsplit(opt$discrete_variables,",")[[1]]
	if(length(varplot1) ==1){
		use.var1 = varplot1
	}else{
		use.var1 <- varplot1[varplot1 %in% colnames(tt)]
	}
	print("Plotting with")
	print(use.var1)
	# check vars are not integers in tt
	tt[,use.var1] <- tt %>% select_at(.vars=use.var1) %>% mutate_all(as.factor)
	

	print("---------------")
	print("plot discrete variables" )
    print("---------------") 
	for (vv in use.var1){
		print(vv)
		tt %>% ggplot(aes_string("UMAP_1", "UMAP_2", color=vv)) + geom_point(size=0.3) + labs(color=vv) +
			theme_bw() +
			theme(legend.key.height=unit(0.5,'cm'), legend.key.width=unit(0.2,'cm'), axis.title = element_text(size=15), axis.text = element_text(size=14)) -> g

		if (vv=="cluster"){
          tt %>% select(UMAP_1,UMAP_2, cluster) %>% group_by(cluster) %>% summarise_all( .funs = median) ->dm
          g <- g + 
               geom_text_repel(data = dm, aes(UMAP_1,UMAP_2, label=cluster), color="black", size=3) +
               guides(colour = guide_legend(override.aes = list(shape=16,size=2)))  
        }

		ggsave(g, filename=paste0(opt$outfile_prefix,"_umap_", vv, "_", opt$coords_suffix, ".png" ), width=7, height=6, type="cairo", dpi=120)
	}


}



##barplots
print("---------------")
print("plot barplots")
print("---------------")
use.var1 <- use.var1[!use.var1=="cluster"]

for (vv in use.var1){
	setlim <- gtools::mixedsort(as.character(unique(tt[,vv])))
	print(vv)
	#print(tt %>% group_by_at(.vars=c("cluster",vv)) %>% summarize(cell_count=n()))
	plot_dat <- tt %>% group_by_at(.vars=c("cluster",vv)) %>% summarize(cell_count=n())
 # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	fprefix = dirname(dirname(opt$outfile_prefix))
	
	plot_dat %>% 
		tidyr::pivot_wider(names_from=vv, values_from="cell_count") %>% 
		write.csv(paste0(fprefix, "/cell_nums_by_cluster_",vv, ".csv"))
 # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	g <- ggplot(plot_dat, aes_string("cluster", "cell_count", fill=vv ))+ geom_bar(stat="identity", position="dodge", color="black") +
		labs(fill=vv) +
		theme_bw() +
		theme(legend.key.height=unit(0.5,'cm'), legend.key.width=unit(0.1,'cm'),
					axis.text = element_text(size=12), axis.title = element_text(size=13, face="bold")) +
		ylab("Number of cells") 
	if(length(unique(tt[,"cluster"])) >12) { ww=23}else{ww=12}

	ggsave(g, filename=paste0(opt$outfile_prefix,"_barplot_cluster_",vv,".png" ), width=ww, height=6, type="cairo")
}

for (vv in use.var1){
	gtools::mixedsort(as.character(unique(tt[,vv]))) ->setlim
	tt %>% group_by_at(.vars=c(vv,"cluster")) %>% summarize(cell_count.per.var=n()) %>%
		group_by_at("cluster") %>%
		mutate(cell_count.per.cluster= sum(cell_count.per.var)) %>%
		mutate(percent=100*cell_count.per.var/cell_count.per.cluster)%>%
		ggplot(aes_string("cluster","percent", fill=vv)) + geom_bar(stat="identity", position="stack", color="black") +
		labs(x="cluster") + theme_bw() +
		theme(axis.text.x = element_text(angle=30, hjust=1, size=12),
					axis.text.y = element_text(size=12),
					axis.title = element_text(size=13, face="bold"),legend.key.height=unit(0.5,'cm'), legend.key.width=unit(0.1,'cm')) +
		ylab("Percent of cells") -> g
	if(length(unique(tt[,"cluster"])) >12) { ww=23}else{ww=12}
	ggsave(g, filename=paste0(opt$outfile_prefix,"_proportion_cluster_",vv,".png" ), width=ww, height=6, type="cairo")
}

##violin plots
print("---------------")
print("plot violins")
print("---------------")

for (vv in use.var1){
	gtools::mixedsort(as.character(unique(tt[,vv]))) ->setlim
	g <- tt %>%  reshape2::melt(id.vars=c("cluster",vv), measure.vars=cont_plot) %>%
		ggplot( aes_string("cluster","value", fill=vv)) +geom_violin()  + facet_wrap(~variable, scales='free', ncol=min(length(cont_plot),2)) +
		theme_bw() +
		theme(legend.key.height=unit(0.5,'cm'), legend.key.width=unit(0.1,'cm'),
			  strip.background.x = element_rect(fill="white", color="white"),
			  strip.text.x = element_text(size=10, face='bold.italic'),
              axis.text.x=element_text(angle=90, hjust=1, vjust=0.5)) +
		ylab("QC value") 

	if(length(unique(tt[,"cluster"])) >12) { ww=23}else{ww=12}
	ggsave(g, filename=paste0(opt$outfile_prefix,"_violin_cluster_",vv,".png" ), width=ww, height=10, type="cairo")
}

print("done")

install.packages("systemfonts", dependencies = TRUE)
cran_packages <- c("optparse", "foreign","clustree","remotes", "table")
for (pp in cran_packages){
  message("============ Installing ", pp, " ============")
  install.packages(pp)
}

if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install(c("ComplexHeatmap", "ggraph", 
    "tidyverse", "ggforce","Seurat"))


remotes::install_github("grimbough/rhdf5")
# remotes::install_github("ilia-kats/MuData")
# remotes::install_github("pmbio/MuDataSeurat")

print(.libPaths())
suppressPackageStartupMessages({library(tidyverse)
library(optparse)
library(Seurat)
library(scales)
library(ggrepel) })
options(stringsAsFactors = F)
options(bitmapType='cairo')

option_list <-  list(
  make_option("--csvpaths", default=NULL,
              help="The txt file containing the paths to metrics.cvs"),
  make_option("--outdir", default=NULL,
              help="The output directory"),
  make_option("--figdir", default=NULL,
              help="The figure directory"),
  make_option("--project", default=NULL,
              help="The project number, or a key word to describe the project"),
  make_option("--height", default=12,
              help="The heigth of the png to save, in cm."),
  make_option("--width", default=12,
              help="The width of the png to save, in cm."),
  make_option("--kneeplot", default=FALSE,
              help="Produce Knee plot? default to false cause it takes time. if set to true specify 10x Chemistry Version")

)

myFun <- function(n = 5000) {
  a <- do.call(paste0, replicate(5, sample(LETTERS, n, TRUE), FALSE))
  paste0(a, sprintf("%04d", sample(9999, n, TRUE)), sample(LETTERS, n, TRUE))
}



opt <- parse_args(OptionParser(option_list=option_list))

if(is.null(opt$outdir)) { opt$outdir <- paste0(getwd(),"/")}
if(!endsWith(opt$outdir,"/")) {opt$outdir <- paste0(opt$outdir,"/")}

if(is.null(opt$figdir)) { opt$figdir <- paste0(getwd(),"/figures/")}
if(!endsWith(opt$figdir,"/")) {opt$figdir <- paste0(opt$figdir,"/")}

if(!dir.exists(opt$figdir)) dir.create(opt$figdir)
# translate strings into bools (because cgat pipeline wil pipe strings)
if(opt$kneeplot == "True"|opt$kneeplot =="TRUE"){
  opt$kneeplot = TRUE
}else{
  opt$kneeplot = FALSE
}

print("Running with options:")
print(opt)
project <- opt$project

if(!is.null(opt$csvpaths)) {
  caf <- read.table(opt$csvpaths, header=T, sep="\t")
  if(!"rna_path" %in% colnames(caf)){
    caf$rna_path=caf$path
    caf <- caf %>% filter(filetype=="cellranger")
    if(nrow(caf)==0){
      message("no cellranger inputs")
      exit()
    }

  }
  # paths <- gsub("filtered_feature_bc_matrix","metrics_summary.csv",caf$rna_path)
  paths <- file.path(caf$rna_path, "metrics_summary.csv")
  
  # paths <- gsub("\\/$","", paths)

  #for(n in paths){ print(n); dd <- read.csv(n, header=T, stringsAsFactors = F) ; mat[n,colnames(dd)] <- gsub("%|,","", dd[1,])}
  #for(n in paths){ print(n); mat[n,] <-gsub("%|,","",read.csv(paste0(n,"metrics_summary.csv"), header=T, stringsAsFactors = F)[1,])}
  listfile <- list()
  for(n in paths){ listfile[[n]] <- read.csv(n, header=T, stringsAsFactors = F) }
  mat<-plyr::ldply(listfile, rbind)
  mat <- as.data.frame(sapply(mat,function(x) gsub("%|,","", x)))
  mat <- mat[,-1]

  if(!is.null(caf$sample_id)){
    rownames(mat)<-caf$sample_id
  }else{
    nm <- strsplit(paths, "/", fixed=T)
    f <- length(nm[[1]]) - 2
    nm <- sapply(nm,"[[",f)
    rownames(mat)<-nm
  }


}

tag.mat <- mat[,grepl("Antibody", colnames(mat))]
tag.mat <- na.omit(tag.mat)
mat <- mat[,!grepl("Antibody", colnames(mat))]
mat <- na.omit(mat)
swr = function(string, nwrap=20) {paste(strwrap(string, width=nwrap), collapse="\n")}
swr = Vectorize(swr)

if(ncol(mat)>0){
  reshape2::melt(as.matrix(mat)) %>%
    mutate(value=as.numeric(as.character(value))) %>% mutate(variable=gsub("."," ",Var2, fixed=T)) %>% mutate(variable=swr(variable)) %>%
    ggplot(aes(Var1,value, fill=Var1)) + facet_wrap(~variable, scales="free") +theme_gray()+geom_bar(stat="identity", position="dodge", color="grey20") +
    theme_bw() +
    theme(axis.text.x = element_text(angle=35,hjust=1,size=6),legend.position = "none",
          strip.text.x = element_text(size = 9, face='bold')) + xlab("") + ylab("") +
    scale_fill_manual(values = hue_pal(l = 80,c(0, 360))(nrow(mat)))-> g
  message("doing first plot")
  ggsave(g,height = opt$height ,width = opt$width, units = "cm", file=paste0(opt$figdir,"10xMetrics_",project,"_plot.pdf") )
  write.table(mat, quote=F, row.names=T,col.names=T,file=paste0(opt$outdir,"10xMetrics_",project,".txt"), sep='\t')
message("done plot")
  mat %>% rownames_to_column("sample_id") %>%
  select(Sequencing.Saturation,Number.of.Reads, Mean.Reads.per.Cell, Estimated.Number.of.Cells, sample_id) %>%
    mutate(Sequencing.Saturation=as.numeric(as.character(Sequencing.Saturation)),
           Number.of.Reads=as.numeric(as.character(Number.of.Reads)),
           Mean.Reads.per.Cell=as.numeric(as.character(Mean.Reads.per.Cell)),
           Estimated.Number.of.Cells=as.numeric(as.character(Estimated.Number.of.Cells))) %>%
    ggplot(aes(Sequencing.Saturation,Number.of.Reads,size=Mean.Reads.per.Cell, color=Estimated.Number.of.Cells,label=sample_id)) +
    geom_point() + theme_bw() + scale_color_viridis_c() + geom_text_repel(size=3, color="black") -> g2

  ggsave(g2,height = 10 ,width = 16, units = "cm", file=paste0(opt$figdir,"10xMetrics_",project,"sequencing_saturation_plot.pdf"))

}
if(ncol(tag.mat)>0){
  reshape2::melt(as.matrix(tag.mat)) %>%
    mutate(value=as.numeric(as.character(value))) %>% mutate(variable=gsub("."," ",Var2, fixed=T)) %>% mutate(variable=swr(variable)) %>%
    ggplot(aes(Var1,value, fill=Var1)) + facet_wrap(~variable, scales="free") +geom_bar(stat="identity", position="dodge") +
    theme_bw()+
    theme(axis.text.x = element_text(angle=35,hjust=1,size=9),legend.position = "none",
          strip.text.x = element_text(size = 9, face='bold')) + xlab("") + ylab("") +
    scale_fill_manual(values = hue_pal(l = 80,c(0, 360))(nrow(tag.mat)))-> g

  ggsave(g,height = opt$height ,width = opt$width, units = "cm", file=paste0(opt$figdir,"10xMetrics_Antibodytag_",project,"_plot.pdf"))
  write.table(tag.mat, quote=F, row.names=T,col.names=T,file=paste0(opt$outdir,"10xMetrics_Antibodytag_",project,".txt"), sep='\t')
  colnames(tag.mat) <- gsub("Antibody..","",colnames(tag.mat), fixed = T)
  tag.mat %>% 
    rownames_to_column("sample_id") %>%
    select(Sequencing.Saturation,Number.of.Reads, Mean.Reads.per.Cell, Antibody.Reads.Usable.per.Cell, sample_id) %>%
    mutate(Sequencing.Saturation=as.numeric(as.character(Sequencing.Saturation)),
           Number.of.Reads=as.numeric(as.character(Number.of.Reads)),
           Mean.Reads.per.Cell=as.numeric(as.character(Mean.Reads.per.Cell)),
           Antibody.Reads.Usable.per.Cell=as.numeric(as.character(Antibody.Reads.Usable.per.Cell))) %>%
    ggplot(aes(Sequencing.Saturation,Number.of.Reads,size=Antibody.Reads.Usable.per.Cell, color=Mean.Reads.per.Cell, label=sample_id)) +
    geom_point() + theme_bw() + scale_color_viridis_c() + geom_text_repel(size=3, color="black") -> g2

  ggsave(g2,height = 10 ,width = 15, units = "cm", file=paste0(opt$figdir,"10xMetrics_Antibodytag",project,"sequencing_saturation_plot.pdf"))

}

if(nrow(mat)==0){mat <- tag.mat}
#modify this to deal with AB reads and rna reads, need to split the knee plotting in 2 if you want both rna and PROT knees in 2 different graphs
if(opt$kneeplot){
  print("plotting kneeplot")
  gsub("metrics_summary.csv","raw_feature_bc_matrix" , paths) ->normpath
  raw<-list()
  
  for( a in 1:length(normpath)){
    print(normpath[a])
    mm<-Read10X(normpath[a])
    if(class(mm)=="list") { mm<-do.call("rbind",mm)} #modify this to deal with prot reads and rna reads, need to split the knee plotting in 2 if you want both rna and prot in 2 different graphs
    colnames(mm) <- paste0(colnames(mm),"_",rownames(mat)[a])
    xx <- CreateSeuratObject(mm,assay = "RNA",  min.cells = 0, min.features = 0)
    xx@meta.data %>%
      rownames_to_column("barcode") %>% 
      arrange(desc(nCount_RNA)) %>% 
      mutate(nobarcode = rownames(mat)[a], 
      barcodes=rank(-nCount_RNA,ties.method = "first")) -> rawrank
    raw[[a]] <- rawrank
  }
  raw.data <-do.call("rbind",raw)
  gsub("raw_feature_bc_matrix", "filtered_feature_bc_matrix", normpath) -> normpath
  
  raw<-list()
  for( a in 1:length(normpath)){
    print(normpath[a])
    mm<-read.table(paste0(normpath[a],"/barcodes.tsv.gz"), header=F, sep="\t") 
    #mm<-Read10X(normpath[a])
    #if(class(mm)=="list") { mm<-do.call("rbind",mm)}
    #colnames(mm) <- paste0(colnames(mm),"_",rownames(mat)[a])
    df <- data.frame( barcode = paste(unlist(mm),rownames(mat)[a], sep="_"), nobarcode =rep(rownames(mat)[a]) )
    raw[[a]] <-df 
  }
  filtered<- do.call("rbind", raw)
  
  raw.data$passfilter <- raw.data$barcode %in% filtered$barcode

  raw.data %>%
  {ggplot(.,aes(y=nCount_RNA, x=barcodes )) + geom_line(size=2,aes(col = nobarcode  ))+
    scale_y_log10(breaks=c(1,10,100,1000,10000, 100000)) +
    scale_x_log10(breaks = c(1,10,100,1000,10000,100000)) + #+ geom_point()
    theme_bw() + geom_hline(yintercept = 1000, linetype="dashed") + 
    theme(legend.key.size = unit(0.2,"cm"), axis.text=element_text(size=13,face="bold", color="black")) +
    scale_color_manual(values = hue_pal(l = 80,c(0, 360))(nrow(mat)))} ->gb
  fl<-gb

  for (bce in unique(raw.data$nobarcode)) {
    print(bce)
    gb+ geom_line(data=dplyr::filter(raw.data, passfilter=="TRUE", nobarcode==bce), aes(y=nCount_RNA, x=barcodes), color="blue", alpha=0.4, size=3.5) +
      scale_y_log10(breaks=c(1,10,100,1000,10000, 100000)) +
      scale_x_log10(breaks = c(1,10,100,1000,10000,100000)) + #+ geom_point()
      theme_bw() + geom_hline(yintercept = 1000, linetype="dashed") + 
      theme(legend.key.size = unit(0.2,"cm"), axis.text=element_text(size=13,face="bold", color="black"))  ->gb }
  gb + fl$layers ->gb

  ggsave(gb,height = 15 ,width = 17, dpi=300, file=paste0(opt$figdir,"10xMetrics_",project,"_rna_knee_plot.png"), type="cairo-png")


}

# if PROT exists then repeat for PROT

message("finished pipeline")
